/* osc.c

    Written by Clément NOTIN for Erasme Centre Multimédia
    Summer 2007
*/

#include <stdio.h> //perror()
#include <string.h> //strlen
#include <stdlib.h> //malloc()
#include <lo/lo.h>

extern char *OSC_IP_ADDRESS;
extern char *OSC_ADDRESS;
extern char *OSC_PORT;

//##########################################################
//used to send OSC messages over UDP, be careful there's no checking if the packet is really sent or not
//take a look at liblo documentation too
void oscSend(const char *sensor, int value)
{
    int addressSize=sizeof(char) * (strlen(sensor) + strlen(OSC_ADDRESS) - 2) + 1; //"-2" not to count "%s" in address template (OSC_ADDRESS)
    char *sAddr=malloc(addressSize);
    sprintf(sAddr, OSC_ADDRESS, sensor); //replace %s by the sensor's name
    
    lo_address addr = lo_address_new(OSC_IP_ADDRESS, OSC_PORT);
    if (!lo_send(addr, sAddr, "i", value))
        perror("lo_send failed ");
    
    lo_address_free(addr);
    free(sAddr);
}
