/* rpn.c

    Code taken from http://www.stacken.kth.se/~foo/rpn/index.shtml#C
    
    Adapted by Clément NOTIN for Erasme Centre Multimédia
    Summer 2007
*/

#include <stdio.h> //fprintf()
#include <ctype.h> //isspace()

//a bit of code taken from http://www.stacken.kth.se/~foo/rpn/index.shtml#C
//there is some modifications, compare the two sources...

#define STACK_SIZE 50 //change it if you use a really complicated RPN expression and get some "stack overflow" errors
#define TOKEN_MAX 20 //change it if you use a long RPN expression (a token is a char between spaces)

//hack to do this : sscanf(linep, "%" Str(TOKEN_MAX) "s", token)
#define _Str(x) #x
#define Str(x) _Str(x)

int stack[STACK_SIZE];
int *sp;
int *sp_max;

#define full() (sp == sp_max)
#define empty() (sp == (stack-1))

void push(int value) {
  if(!full()) *(++sp) = value;
  else fprintf(stderr, "Stack overflow\n");
}

int pop() {
  if(!empty()) return *(sp--);
  fprintf(stderr, "Stack underflow\n");
  return 0;
}

int apply_operator(char op, int first, int second) {
  switch(op) {
  case '+': return first + second;
  case '-': return first - second;
  case '*': return first * second;
  case '/': return first / second;
  //these two ones are added from the original code because we needed it
  case '>' : return first >> second;
  case '<' : return first << second;
  default: fprintf(stderr, "Bad operator: %c\n", op);
    return 0;
  }
}

char *next_token(char *linep) {
  while(isspace(*(linep++)));
  while(*linep && !isspace(*(linep++)));
  return linep;
}

//main function used to compute the RPN expression, "*linep" is the expression and "replace" the value which will be used to replace X in *linep
//return the result of the calculation
int rpn(char *linep, int replace) {
  while(1) {
    sp = stack-1;
    sp_max = &stack[STACK_SIZE-1];
    int value;
    while(1) {
      char token[TOKEN_MAX+1];
      if(!linep) break;
      if(sscanf(linep, "%" Str(TOKEN_MAX) "s", token) != 1)
        break;
      if(sscanf(token, "%i", &value)) push(value);
      else if(token[0] == 'X') { push(replace); } //'X' char is replaced by "replace" value which is normally read from the arduino
      else {
        int second = pop();
        int first = pop();
        push(apply_operator(token[0], first, second));
      }
      linep = next_token(linep);
    }
    if(!empty()) return *sp;
  }
}
